'
' ClearLNK by Alex Dragokas ver.1.3
' 
'      (.LNK)
'    ,     URL.
'
' :
'  -  1)         (   )
'  -  2)         
'  -  3)      (txt, log)   
'

Option Explicit

Dim oShellApp: Set oShellApp = CreateObject("Shell.Application")
Dim oShell:    Set oShell    = CreateObject("WScript.Shell")
Dim oFSO:      Set oFSO      = CreateObject("Scripting.FileSystemObject")
Dim oRegEx:    Set oRegEx    = CreateObject("VBScript.RegExp")

Dim LNK, arg
Dim ver: ver = "1.3"
Dim AppName: AppName = "ClearLNK ver. " & ver & " by Alex Dragokas"
Dim cur, temp, LinksTXT, n: n = 0
Dim oTSW, oMatches, LnkCnt: LnkCnt = 0

cur  = oFSO.GetParentFolderName(WScript.ScriptFullName)
temp = oShell.ExpandEnvironmentStrings(oShell.ExpandEnvironmentStrings("%temp%")) '  ,      

If WScript.Arguments.Count > 0 Then 
	LNK = WScript.Arguments(0)
	if Not CureObject(LNK, True) Then MsgBox "     !",,AppName: WScript.Quit 1
Else
	Call CheckPrivileges(temp)
	do
		n = n + 1
		LinksTXT = temp & "\ClearLNK_Links_" & n & ".txt"
	loop while oFSO.FileExists(LinksTXT)
    On Error Resume next
	Err.Clear
	Set oTSW = oFSO.CreateTextFile (LinksTXT, True)
		oTSW.WriteLine vbCrLf & vbCrLf & "     (   )     :" & vbCrLf & vbCrLf
	oTSW.Close: Set oTSW = Nothing
	if Err <> 0 Then
		MsgBox "   .  = " & Err & " (" & Err.Description & ")" & vbCrLf & ",     TEMP    ."
		WScript.Quit 1
	end if
	On Error Goto 0
	oShell.Run "notepad.exe" & " " & """" & LinksTXT & """", 1, True
	Call CureListLNK(LinksTXT)
end if
if oFSO.FileExists(LinksTXT) Then oFSO.DeleteFile LinksTXT, True

MsgBox "       : " & LnkCnt, vbInformation, AppName

Function CureListLNK(LinksTXT)	'     
	Dim sLine, oTSR
    On Error Resume next
	Set oTSR = oFSO.OpenTextFile (LinksTXT, 1, False)
	Do until oTSR.AtEndOfStream
		sLine = oTSR.ReadLine
		Call CureLinkLine(sLine)
	Loop
	oTSR.Close: Set oTSR = Nothing
End Function

Function CureLinkLine(ByVal sLine)	'     ,   1 
	Dim n
	sLine = Trim(sLine)													'trim
    oRegEx.IgnoreCase = True
    oRegEx.Global = True
    oRegEx.Pattern = """?.:\\[^""]*\.(lnk|url|log)""?"					'just lnk / url / log
    Set oMatches = oRegEx.Execute(sLine)
    If oMatches.Count Then
		For n = 1 To oMatches.Count
			sLine = oMatches.Item(n - 1).Value
		    sLine = UnQuote(sLine)										'unQuote
			LNK = FindLNK(sLine)										'check Existance
			if LNK <> "" Then Call CureObject(LNK, False)				'begin Cure
		Next
	end if
	Set oMatches = Nothing
End Function

Function CureObject(file, CanBeList)	'   (   - LNK / URL / TXT / LOG)
	CureObject = True
	if Not oFSO.FileExists(file) Then Exit Function
	Select Case CheckValidExtension(file)
	Case ""
		CureObject = False
	Case "LNK"
		LnkCnt = LnkCnt + 1
		Call FixLNK(file)
	Case "URL"
		Call FixURL(file)
	Case "LOG"
		if CanBeList Then Call ParseCheckBrowserLNK_LOG(file)
	Case "TXT"
		if CanBeList Then Call CureListLNK(file)
	End Select
End Function

Function FixLNK(file)	'    LNK
	On Error Resume next
	Dim ClearBrowserPath
	Call CheckPrivileges(oFSO.GetParentFolderName(file))
	with oShell
		with .CreateShortcut(file)
			Dim LNK_Targ:   LNK_Targ   = .TargetPath
			Dim LNK_Args:	LNK_Args   = .Arguments
			Dim LNK_Descr:  LNK_Descr  = .Description
			Dim LNK_Key:    LNK_Key    = .HotKey
			Dim LNK_Icon:   LNK_Icon   = .IconLocation
			Dim LNK_Style:  LNK_Style  = .WindowStyle
			Dim LNK_WDir:   LNK_WDir   = .WorkingDirectory
		end with

		'    cmd.exe
		if LCase(oFSO.GetBaseName(LNK_Targ)) = "cmd" Then
			ClearBrowserPath = FindKnownBrowserName(LNK_Args, file)
			if ClearBrowserPath = "" Then
				Exit Function
			Else
				LNK_Targ = ClearBrowserPath
				LNK_WDir = oFSO.GetParentFolderName(ClearBrowserPath)
			end if
		end if

		'      URL
		Dim Ext, Relink, AssumeOK
		Relink = False: AssumeOK = False
		Ext = LCase(oFSO.GetExtensionName(LNK_Targ))
		if Ext = "url" Then
			Relink = True
			'   URL  EXE
			LNK_Targ = oFSO.GetParentFolderName(LNK_Targ) & "\" & oFSO.GetBaseName(LNK_Targ) & ".exe"
			if oFSO.FileExists(LNK_Targ) Then AssumeOK = True '  
		end if

		oFSO.DeleteFile file, True
		if Err <> 0 Then Call Elevate()
		
		Dim ArgIsSafe, Ch ' ,     (   -  /)
		Ch = Left(LNK_Args, 1)
		ArgIsSafe = (Ch = "-" Or Ch = "/")

		with .CreateShortcut(file)
			.Description        = LNK_Descr
			.HotKey             = LNK_Key
			.IconLocation       = LNK_Icon
			.TargetPath         = LNK_Targ
			.WindowStyle        = LNK_Style
			.WorkingDirectory   = LNK_WDir
			if Relink And ArgIsSafe Then .Arguments = LNK_Args
			.Save
		end with
	end with
	if Relink And Not AssumeOK Then MsgBox " ,       ." & vbCrLf & _
										   "Windows    ." & vbCrLf &_
										   "   .",,AppName
End Function

Function FindKnownBrowserName(Str, file)	' ,      ;       ( App Paths)
	On Error Resume Next
    Dim Browser, Ext, ParentPath, sPath
    oRegEx.IgnoreCase = True
    oRegEx.Global = True
    oRegEx.Pattern = "("".:\\[^""]*\\|.:\\[^ ""]*\\|"")?" & _
                     "(iexplore|chrome|firefox|opera|browser|dragon|icedragon|" & _
                     "nichrome|seamonkey)(\.exe)?""?"
    Set oMatches = oRegEx.Execute(Str)
    If oMatches.Count Then
        Browser = oMatches.Item(0).Value
        ParentPath = oFSO.GetParentFolderName(Browser)
        Ext = oFSO.GetExtensionName(Browser)
        If Ext = "" Then Browser = Browser & ".exe"
        If ParentPath = "" Then '      ,    App Path
            Browser = UnQuote(Browser)
            sPath = oShell.RegRead("HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\" & Browser & "\")
            'sPath = Split(sPath, ";")(0)
            Browser = UnQuote(sPath) '& "\" & Browser
        End If
        FindKnownBrowserName = Browser
    Else    '       .
        MsgBox "  : " & file & vbCrLf & vbCrLf & "     ." & vbCrLf & ",    : Audilyzer@i.ua",,AppName
    End If
End Function

Function UnQuote(Str)	'   (  )
    Dim s: s = Str
    Do While Left(s, 1) = """"
        s = Mid(s, 2)
    Loop
    Do While Right(s, 1) = """"
        s = Left(s, Len(s) - 1)
    Loop
    UnQuote = s
End Function

Function FixURL(file)	'   URL ( )
	On Error Resume next
	Call CheckPrivileges(oFSO.GetParentFolderName(file))
	with oShell
		with .CreateShortcut(file)
			Dim URL_Targ:   URL_Targ   = .TargetPath
		end with

		oFSO.DeleteFile file, True
		if Err <> 0 Then Call Elevate()

		with .CreateShortcut(file)
			.TargetPath   = URL_Targ
			.Save
		end with
	end with
End Function

Function ParseCheckBrowserLNK_LOG(file)	'  CheckBrowserLNK by glax24
	Dim arr:	arr = ReadFileToArray(file, "UTF-16LE", "windows-1251")
	Dim Line, LinksBegin
	LinksBegin = False
	For each Line In arr
		if LinksBegin Then
			if Left(Line, 3) = "===" Then Exit Function
			Call ParseCheckBrowserLNK_LogLine(Line)
		end if
		if InStr(1, Line, "[ Browser with parameters ]", 1) <> 0 Then LinksBegin = True
	Next
	if Not LinksBegin Then Call CureListLNK(file)	'     CheckBrowserLNK ->      
End Function

Function ParseCheckBrowserLNK_LogLine(Line)	'  1   CheckBrowserLNK by glax24
	Dim pos, file
	pos = 0
	Do
		pos = pos + 1
		pos = InStr(pos, Line, "[")
		if pos <> 0 Then 
			file = Trim(Left(Line, pos - 1))
			if oFSO.FileExists(file) Then
				Call CureObject(file, False) '   (main -> CureObject -> ParseCheckBrowserLNK_LOG -> ParseCheckBrowserLNK_LogLine -> CureObject)
				Exit Do
			end if
		end if
	Loop while pos
End function

Function FindLNK(file) ' LNK, URL  LOG,      
	Dim Ext, AssumeName, pos: pos = 0
	For each Ext In Array("", ".LNK", ".LOG", ".TXT") '".URL"
		if oFSO.FileExists(file & Ext) Then FindLNK = file & Ext: Exit Function
	Next
	On Error Resume Next
	Do while instr(pos + 1, file, " ") <> 0	'  
		pos = instr(pos + 1, file, " ")
		AssumeName = left(file, pos - 1) & Mid(file, pos + 1)
		if oFSO.FileExists(AssumeName) then FindLNK = AssumeName: Exit Do
	Loop
End Function

Function CheckValidExtension(file)	' ,        
	Dim Ext
	For each Ext In Array("LNK", "LOG", "TXT") '"URL"
		if UCase(oFSO.GetExtensionName(file)) = Ext Then CheckValidExtension = Ext: Exit For
	Next	
End Function

Sub Elevate()	' UAC
    if MsgBox("  ." & vblf & " ClearLNK    ?",vbQuestion+vbYesNo,"") = vbNo Then WScript.Quit 5    
    oShellApp.ShellExecute WScript.FullName, """" & WScript.ScriptFullName & """" & " " & """" & LNK & """", "", "runas", 1
	WScript.Quit 0
End Sub

Function ReadFileToArray(file, srcEncode, destEncode)	'     
	Dim Text
    With CreateObject("ADODB.Stream")
		.Type = 2
		.Charset = srcEncode
        .Open
		.LoadFromFile file
		if .Size = 0 Then WScript.Quit 2
		Text = .ReadText()
		.Close
		.Charset = destEncode
		.Open
		.WriteText (Text)
		.Position = 0
		Text = .ReadText()
		.Close
	end with
	ReadFileToArray = Split(Text, vbCrLf)
End Function

Function CheckPrivileges(path)	'         
	Dim tmpfile, oTSW
	tmpfile = oFSO.BuildPath(path, oFSO.GetTempName())
	if oFSO.FileExists(tmpfile) Then
		Call GetTempFileName(path)
	Else
		On Error Resume next
		Set oTSW = oFSO.CreateTextFile(tmpfile,False)
		if err <> 0 Then
			Call Elevate()
		Else
			oTSW.Close
			oFSO.DeleteFile tmpfile
		end if
	end if
End Function
